#include <assert.h>
#include <stdlib.h>
#include <erl_nif.h>

static int rtc_load(ErlNifEnv *, void **, ERL_NIF_TERM);
static void rtc_resource_destroy(ErlNifEnv *, void *);
static int rtc_upgrade(ErlNifEnv *, void **, void **, ERL_NIF_TERM);
static ERL_NIF_TERM foo(ErlNifEnv *, int, const ERL_NIF_TERM[]);
static ERL_NIF_TERM bar(ErlNifEnv *, int, const ERL_NIF_TERM[]);

static ErlNifFunc api[] = {
	{ "foo", 0, foo, 0 },
	{ "bar", 0, bar, 0 },
};
ERL_NIF_INIT(rtc, api, &rtc_load, NULL, &rtc_upgrade, NULL);

static ErlNifResourceType *rtc_resource;

static int
rtc_load(ErlNifEnv *env, void **priv_data, ERL_NIF_TERM nif_context)
{
	rtc_resource = enif_open_resource_type(env, NULL, "rtc",
	    rtc_resource_destroy, ERL_NIF_RT_CREATE | ERL_NIF_RT_TAKEOVER,
	    NULL);
        assert(rtc_resource != NULL);
	return (0);
}

static void
rtc_resource_destroy(ErlNifEnv *env, void *obj)
{
}

static int
rtc_upgrade(ErlNifEnv *env, void **priv_data, void **old_priv_data,
    ERL_NIF_TERM load_info)
{
	return (0);
}

static ERL_NIF_TERM
foo(ErlNifEnv *env, int argc, const ERL_NIF_TERM argv[])
{
	void **resource;
	ERL_NIF_TERM result;

	resource = enif_alloc_resource(rtc_resource, sizeof (void *));
	assert(resource != NULL);
	result = enif_make_resource(env, resource);
	enif_release_resource(resource);
	return (result);
}

static ERL_NIF_TERM
bar(ErlNifEnv *env, int argc, const ERL_NIF_TERM argv[])
{
        return (enif_make_atom(env, "ok"));
}
